import { DecorationEvent, LevelEvent } from './events.js'

type AngleData = number[]

export interface Level {
  angleData: AngleData
  settings: LevelSettings
  actions: LevelEvent[]
  decorations: DecorationEvent[]
}

export interface LevelSettings {
  version: 12
  artist: ''
  specialArtistType: 'None'
  artistPermission: ''
  song: ''
  author: ''
  separateCountdownTime: 'Enabled'
  previewImage: ''
  previewIcon: ''
  previewIconColor: '003f52'
  previewSongStart: 0
  previewSongDuration: 10
  seizureWarning: 'Disabled'
  levelDesc: ''
  levelTags: ''
  artistLinks: ''
  difficulty: 1
  requiredMods: []
  songFilename: 'L_X.wav'
  bpm: 107.5
  volume: 100
  offset: 502
  pitch: 100
  hitsound: 'Sizzle'
  hitsoundVolume: 100
  countdownTicks: 4
  trackColorType: 'Single'
  trackColor: 'ffffffaa'
  secondaryTrackColor: 'ffffff'
  trackColorAnimDuration: 2
  trackColorPulse: 'None'
  trackPulseLength: 10
  trackStyle: 'Minimal'
  trackGlowIntensity: 50
  trackAnimation: 'Fade'
  beatsAhead: 6
  trackDisappearAnimation: 'Fade'
  beatsBehind: 0
  backgroundColor: '000000'
  showDefaultBGIfNoImage: 'Disabled'
  bgImage: ''
  bgImageColor: 'ffffff'
  parallax: [100, 100]
  bgDisplayMode: 'Unscaled'
  lockRot: 'Disabled'
  loopBG: 'Disabled'
  unscaledSize: 100
  relativeTo: 'Player'
  position: [0, 0]
  rotation: 0
  zoom: 175
  pulseOnFloor: 'Enabled'
  startCamLowVFX: 'Disabled'
  bgVideo: ''
  loopVideo: 'Disabled'
  vidOffset: 0
  floorIconOutlines: 'Disabled'
  stickToFloors: 'Enabled'
  planetEase: 'Linear'
  planetEaseParts: 1
  planetEasePartBehavior: 'Mirror'
  customClass: ''
  legacyFlash: false
  legacyCamRelativeTo: false
  legacySpriteTiles: false
}
