import JSON5 from 'json5'
import { Level } from '../types'

export const parseADOFAILevel = (level: string): Level => {
  try {
    return JSON5.parse(level)
  } catch (e) {
    const formattedLevel = String(level)
      .trim()
      .replaceAll('\r\n', '\n')
      .replaceAll(', ,', ',')
      .replaceAll(',,', ',')
      .replaceAll('],\n}', ']\n}')
      .replaceAll('}\n', '},\n')
      .replaceAll('},\n\t]', '}\n\t]')
      .replaceAll(', },', ' },')
      .replaceAll(', }', ' }')
      .replaceAll('\n', '')
      .replaceAll('}\n', '},\n')
      .replaceAll(']\n\t"decorations', '],\n\t"decorations')
      .replaceAll(']\t"decorations', '],\t"decorations')
      .replaceAll('\r', '')

    return JSON5.parse(formattedLevel)
  }
}
